ethikdo/cartekdo/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.homePage, name="home"),
    path('login/', views.loginPage, name="login"),
    path('logout/', views.logoutUser, name="logout")

]

ethikdo/ethikdo/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('cartekdo/', include('cartekdo.urls')),
    path('admin/', admin.site.urls),
]

ethikdo/cartekdo/models.py
from django.db import models
from random import randrange
from django.contrib.auth.models import User
from django.core.validators import MaxValueValidator, MinValueValidator


def generate_number():
    while True:
        number = randrange(10**15, 10**16-1)
        cartes = Card.objects.filter(unique_number=number)
        if not cartes:
            return number


class Card(models.Model):
    amount = models.IntegerField(
        validators=[MinValueValidator(20), MaxValueValidator(250)])
    unique_number = models.BigIntegerField(default=generate_number)

    def valid_payment(self, debited_amount):
        return self.amount - debited_amount >= 0

    def amount_update(self, debited_amount):
        return self.amount - debited_amount


class Transaction(models.Model):
    client_card = models.ForeignKey(Card, on_delete=models.CASCADE)
    date_transaction = models.DateTimeField(auto_now_add=True)
    debited_amount = models.IntegerField()
    marchand = models.ForeignKey(User, on_delete=models.CASCADE)

ethikdo/cartekdo/forms.py
from django import forms


class PaimentForm(forms.Form):
    card_number = forms.IntegerField(label="Numéro de la carte",
                                     help_text="C'est le numéro à 16 chiffres de la carte", required=True, min_value=10**15, max_value=10**16-1)
    debited_amount = forms.FloatField(
        label="Montant de l'achat", required=True)

ethikdo/cartekdo/views.py
from django.shortcuts import render, redirect
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.contrib.auth import authenticate, login, logout
from .forms import PaimentForm
from .models import Card, Transaction


@login_required(login_url='login')
def homePage(request):
    form = PaimentForm()
    context = {'form': form}
    if request.method == 'POST':
        form = PaimentForm(request.POST)

        if form.is_valid():
            try:
                card_number = form.cleaned_data['card_number']
                card = Card.objects.get(unique_number=card_number)
                debited_amount = form.cleaned_data['debited_amount']

                if card.valid_payment(debited_amount):
                    Transaction.objects.create(
                        client_card=card, debited_amount=debited_amount, marchand=request.user)
                    card.amount = card.amount_update(debited_amount)
                    card.save()
                    context["transaction"] = "Transaction validée avec succès!"
                else:
                    messages.info(
                        request, "Pas assez d'argent sur cette carte...")
                    form = Paiement()

            except Card.DoesNotExist:

                messages.info(request, 'Numero de carte Introuvable')
                form = PaimentForm()

    return render(request, 'cartekdo/home.html', context)


def loginPage(request):
    if request.user.is_authenticated:
        return redirect('home')
    else:
        if request.method == 'POST':
            username = request.POST.get('username')
            password = request.POST.get('password')

            user = authenticate(request, username=username, password=password)

            if user is not None:
                login(request, user)
                return redirect('home')
            else:
                messages.info(request, 'Username OR password is incorrect')

        context = {}
        return render(request, 'cartekdo/login.html', context)


def logoutUser(request):
    logout(request)
    return redirect('login')

ethikdo/cartekdo/templates/cartekdo/base.html
{% load static %}
<!Doctype html>
<html>

<head>

    <meta charset="utf-8">
    <title>
        Ethikdo
    </title>
    <link href="{% static 'cartekdo/css/bootstrap.min.css' %}" rel="stylesheet">
    <link href="{% static 'cartekdo/css/style.css' %}" rel="stylesheet">


</head>

<body>
    {% if messages %}
    {% for message in messages %}
    <div {% if message.tags %} class="alert alert-{{ message.tags }}" {% endif %}>{{ message }}</div>
    {% endfor %}
    {% endif %}

    {% block content %} {% endblock %}

</body>

</html>

ethikdo/cartekdo/templates/cartekdo/home.html
{% extends 'cartekdo/base.html' %}

{% block content %}
<h1> Bienvenue {{request.user.username}} !</h1>
{% if transaction %}
<div class="content-title">
    <h1> {{transaction}} </h1>
</div>

{% else %}

{% if perms.cartekdo.add_transaction %}
<div class="content-title">
    <h1 id="pay-title">Réaliser un paiement par carte EthiKdo</h1>
</div>
<form id="pay-form" method="POST">
    {% csrf_token %}
    {% for field in form %}
    <label> {{field.label}}</label>
    <div>{{field}}</div>
    <div id="help">{{field.help_text}}</div>
    {% endfor %}
    <button type="submit" class="btn btn-success">Valider</button>

</form>

{% endif %}
{% endif %}
<footer>
    <button class="btn btn-success"><a id="logout" href="{% url 'logout' %}">Logout</a></button>
</footer>
{% endblock %}

ethikdo/cartekdo/templates/cartekdo/login.html
{% extends 'cartekdo/base.html' %}

{% block content %}
<div class="login-content">
    <h1> Login </h1>

    <form method="POST">
        {% csrf_token %}
        <div class="input-group mb-3">

            <input type="text" name="username" placeholder="Username..." class="form-control">
        </div>

        <div class="input-group mb-2">

            <input type="password" name="password" placeholder="Password..." class="form-control">
        </div>

        <div>
            <input class="btn btn-success" type="submit" value="Login">
        </div>

    </form>
</div>
{% endblock %}